<?php

if ( !defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

if ( !class_exists( 'Osteo_Syntax_Highlighter_Assets_Manager' ) ) {

    class Osteo_Syntax_Highlighter_Assets_Manager {

        private static $_instance = null;
        public static function instance() {
            if ( is_null( self::$_instance ) ) {
                self::$_instance = new self();
            }
            return self::$_instance;
        }

        public function __construct() {
            add_action( "elementor/frontend/after_enqueue_styles", [$this, 'frontend_enqueue_styles'] );
            add_action( 'elementor/frontend/after_enqueue_scripts', [$this, 'frontend_enqueue_scripts'] );
        }

        public function frontend_enqueue_styles() {

            wp_enqueue_style( 'atom-one-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/atom-one-dark/atom-one-dark.css' );
            wp_enqueue_style( 'atom-one-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/atom-one-light/atom-one-light.css' );
            wp_enqueue_style( 'ayu-dark-bordered', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-dark-bordered.css' );
            wp_enqueue_style( 'ayu-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-dark.css' );
            wp_enqueue_style( 'ayu-light-bordered', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-light-bordered.css' );
            wp_enqueue_style( 'ayu-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-light.css' );
            wp_enqueue_style( 'ayu-mirage-bordered', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-mirage-bordered.css' );
            wp_enqueue_style( 'ayu-mirage', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/ayu/ayu-mirage.css' );
            wp_enqueue_style( 'bluloco-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/bluloco-light/bluloco-light.css' );
            wp_enqueue_style( 'bracket-lights-pro', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/bracket-lights-pro/bracket-lights-pro.css' );
            wp_enqueue_style( 'coldark-cold', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/coldark/coldark-cold.css' );
            wp_enqueue_style( 'coldark-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/coldark/coldark-dark.css' );
            wp_enqueue_style( 'darcula', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/darcula/darcula.css' );
            wp_enqueue_style( 'doutone-dark-earth', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/doutone-dark/doutone-dark-earth.css' );
            wp_enqueue_style( 'doutone-dark-forest', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/doutone-dark/doutone-dark-forest.css' );
            wp_enqueue_style( 'doutone-dark-sea', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/doutone-dark/doutone-dark-sea.css' );
            wp_enqueue_style( 'doutone-dark-sky', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/doutone-dark/doutone-dark-sky.css' );
            wp_enqueue_style( 'doutone-dark-space', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/doutone-dark/doutone-dark-space.css' );
            wp_enqueue_style( 'dracula', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/dracula/dracula.css' );
            wp_enqueue_style( 'github-dark-colorblind', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-dark-colorblind.css' );
            wp_enqueue_style( 'github-dark-default', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-dark-default.css' );
            wp_enqueue_style( 'github-dark-dimmed', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-dark-dimmed.css' );
            wp_enqueue_style( 'github-dark-high-contrast', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-dark-high-contrast.css' );
            wp_enqueue_style( 'github-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-dark.css' );
            wp_enqueue_style( 'github-light-colorblind', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-light-colorblind.css' );
            wp_enqueue_style( 'github-light-default', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-light-default.css' );
            wp_enqueue_style( 'github-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/github/github-light.css' );
            wp_enqueue_style( 'lws-blue-velvet', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-blue-velvet.css' );
            wp_enqueue_style( 'lws-dracula-version', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-dracula-version.css' );
            wp_enqueue_style( 'lws-peace-of-eye-dracula-version', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-peace-of-eye-dracula-version.css' );
            wp_enqueue_style( 'lws-peace-of-eye', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-peace-of-eye.css' );
            wp_enqueue_style( 'lws-shades-of-gray', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-shades-of-gray.css' );
            wp_enqueue_style( 'lws-simple-as-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-simple-as-light.css' );
            wp_enqueue_style( 'lws-theme', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-theme.css' );
            wp_enqueue_style( 'lws-vintage', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/learnwithsumit/lws-vintage.css' );
            wp_enqueue_style( 'monokai-pro-machine', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokai-pro-machine.css' );
            wp_enqueue_style( 'monokai-pro-octagon', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokai-pro-octagon.css' );
            wp_enqueue_style( 'monokai-pro-restretto', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokai-pro-restretto.css' );
            wp_enqueue_style( 'monokai-pro-spectrum', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokai-pro-spectrum.css' );
            wp_enqueue_style( 'monokai-pro', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokai-pro.css' );
            wp_enqueue_style( 'monokoi-classic', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/monokai-pro/monokoi-classic.css' );
            wp_enqueue_style( 'night-owl-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/night-owl/night-owl-light.css' );
            wp_enqueue_style( 'night-owl', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/night-owl/night-owl.css' );
            wp_enqueue_style( 'nord', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/nord/nord.css' );
            wp_enqueue_style( 'nd-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/nu-disco/nd-dark.css' );
            wp_enqueue_style( 'nd-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/nu-disco/nd-light.css' );
            wp_enqueue_style( 'one-dark-pro-darker', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/one-dark-pro/one-dark-pro-darker.css' );
            wp_enqueue_style( 'one-dark-pro-flat', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/one-dark-pro/one-dark-pro-flat.css' );
            wp_enqueue_style( 'one-dark-pro', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/one-dark-pro/one-dark-pro.css' );
            wp_enqueue_style( 'quiet-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/quiet-light/quiet-light.css' );
            wp_enqueue_style( 'shades-of-purple', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/shades-of-purple/shades-of-purple.css' );
            wp_enqueue_style( 'sm-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/sublime-material/sm-dark.css' );
            wp_enqueue_style( 'sm-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/sublime-material/sm-light.css' );
            wp_enqueue_style( 'synthwave-84', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/synthwave-84/synthwave-84.css' );
            wp_enqueue_style( 'tokyo-night-storm', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/tokyo-night/tokyo-night-storm.css' );
            wp_enqueue_style( 'tokyo-night', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/tokyo-night/tokyo-night.css' );
            wp_enqueue_style( 'abyss-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/abyss-dark.css' );
            wp_enqueue_style( 'dark-plus', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/dark-plus.css' );
            wp_enqueue_style( 'dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/dark.css' );
            wp_enqueue_style( 'high-contrast', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/high-contrast.css' );
            wp_enqueue_style( 'kimbie-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/kimbie-dark.css' );
            wp_enqueue_style( 'light-plus', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/light-plus.css' );
            wp_enqueue_style( 'light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/light.css' );
            wp_enqueue_style( 'monokai-dimmed', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/monokai-dimmed.css' );
            wp_enqueue_style( 'monokai', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/monokai.css' );
            wp_enqueue_style( 'red', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/red.css' );
            wp_enqueue_style( 'solarized-dark', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/solarized-dark.css' );
            wp_enqueue_style( 'solarized-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/solarized-light.css' );
            wp_enqueue_style( 'tomorrow-night-blue', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/vscode-default/tomorrow-night-blue.css' );
            wp_enqueue_style( 'wic-dark-black', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/winter-is-coming/wic-dark-black.css' );
            wp_enqueue_style( 'wic-dark-blue', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/winter-is-coming/wic-dark-blue.css' );
            wp_enqueue_style( 'wic-light', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/themes/winter-is-coming/wic-light.css' );
            wp_enqueue_style( 'prism-diff-highlight', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/diff-highlight/prism-diff-highlight.min.css' );
            wp_enqueue_style( 'prism-inline-color', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/inline-color/prism-inline-color.min.css' );
            wp_enqueue_style( 'prism-line-numbers', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/line-numbers/prism-line-numbers.min.css' );
            wp_enqueue_style( 'prism-match-braces', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/match-braces/prism-match-braces.min.css' );
            wp_enqueue_style( 'prism-previewers', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/previewers/prism-previewers.min.css' );
            wp_enqueue_style( 'prism-toolbar', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/toolbar/prism-toolbar.min.css' );
            wp_enqueue_style( 'prism-treeview', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/treeview/prism-treeview.min.css' );
            wp_enqueue_style( 'osteo-syntax-highlighter-style', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'css/style.css' );

        }

        public function frontend_enqueue_scripts() {

            wp_enqueue_script( 'prism', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/prism.js', array( 'jquery' ), '1.25.0', true );
            wp_enqueue_script( 'prism-line-numbers', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/line-numbers/prism-line-numbers.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-line-highlight', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/line-highlight/prism-line-highlight.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-toolbar', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/toolbar/prism-toolbar.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-copy-to-clipboard', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/copy-to-clipboard/prism-copy-to-clipboard.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-diff-highlight', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/diff-highlight/prism-diff-highlight.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-highlight-keywords', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/highlight-keywords/prism-highlight-keywords.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-inline-color', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/inline-color/prism-inline-color.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-match-braces', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/match-braces/prism-match-braces.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-normalize-whitespace', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/normalize-whitespace/prism-normalize-whitespace.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-previewers', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/previewers/prism-previewers.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-show-language', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/show-language/prism-show-language.js', array( 'jquery' ), '1.0.0', true );
            wp_enqueue_script( 'prism-treeview', OSTEO_SYNTAX_HIGHLIGHTER_ASSETS . 'vendor/prism/treeview/prism-treeview.js', array( 'jquery' ), '1.0.0', true );
            
        }

    }

    Osteo_Syntax_Highlighter_Assets_Manager::instance();

}