<?php

if ( !defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

if ( !class_exists( 'Osteo_Syntax_Highlighter_Widgets_Manager' ) ) {

    class Osteo_Syntax_Highlighter_Widgets_Manager {

        private static $_instance = null;
        public static function instance() {
            if ( is_null( self::$_instance ) ) {
                self::$_instance = new self();
            }
            return self::$_instance;
        }

        public function __construct() {

            // Add Plugin actions
            add_action( "elementor/widgets/widgets_registered", [$this, 'init_widgets'] );
        }

        // Controll Widgets
        public function init_widgets() {

            $widgets_manager = \Elementor\Plugin::instance()->widgets_manager;

            require_once OSTEO_SYNTAX_HIGHLIGHTER_PATH . 'widgets/syntax-highlighter.php';
            \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Osteo_Syntax_Highlighter() );

        }

    }

    Osteo_Syntax_Highlighter_Widgets_Manager::instance();

}